/*	math.h	4.6	9/11/85	*/

/* Copyright (c) 1988 NeXT, Inc. - 9/8/88 CCH */

/* ensure single inclusion of these definitions */
#ifndef _MATH_H
#define _MATH_H

#ifdef __STRICT_BSD__
extern int errno;
#else /* __STRICT_BSD__ */
#import <errno.h>
#endif /* __STRICT_BSD__ */

/* match definition in <sybpes.h> */
#define	EDOM		33		/* Argument too large */
#define	ERANGE		34		/* Result too large */

/* contained in the libm library */
#ifndef __STRICT_ANSI__
extern double asinh(double x), acosh(double x), erf(double x), erfc(double x);
extern double lgamma(double x), hypot(double x, double y);
/* cabs not prototyped because compiler cannot match types as documented */
extern double cabs(), copysign(double x, double y);
extern int finite(double x);
extern double j0(double x), j1(double x), jn(int n, double x);
extern double y0(double x), y1(double x), yn(int n, double x);
extern double cbrt(double x);
#endif
extern double pow(double x, double y), floor(double x), ceil(double x);
extern double atan2(double x, double y);
extern double drem(double x, double y);
extern double scalb(double x, int n);
extern double fmod(double x, double y);

/* contained in the libc library */
/* stdlib.h has def of atof */
extern double modf(double value, double *iptr);
extern double ldexp(double value, int exp);
extern double frexp(double value, int *eptr);

/* compiled inline by the GNU C compiler, non-inline version in libm */
#ifndef __STRICT_ANSI__
extern double atanh(double x), expm1(double x), logb(double x);
extern double log1p(double x), rint(double x);
#endif
extern double acos(double x), asin(double x), atan(double x);
extern double cos(double x), cosh(double x), exp(double x);
extern double fabs(double x), log(double x), log10(double x);
extern double sin(double x), sinh(double x), sqrt(double x);
extern double tan(double x), tanh(double x);

/*
 * Import architecture specific math definitions. 
 */
#import	<ansi/machine/math.h>

#endif /* _MATH_H */
